$(function () {
// クッキー名
	var cookieName = 'searchHistory_clipbag';

	// ハイライト用クエリ
	var searchQuery = '';

	// 検索履歴
	var searchHistoryNum = 5;
	var searchHistory = [];
	searchHistoryCreate();

	// LazyLoad
	$("img.lazy").lazyload({
		skip_invisible: true,
		threshold: 99999999
	});

	// NAV RESET
	$('nav>ul>li>ul').hide();
	var nowIn = 'index';
	hashCheck();


	// NAV固定
	var mainH;
	var sideH;


	// ページ移動
	function move(n) {
		console.log('move:' + n);

		var a = '';
		if (n.match('__')) {
			a = n.split('__')[1];
			n = n.split('__')[0];
		}

		$('#searchResults').hide();
		$('article').hide();
		$('article#c_' + n).show();

		// NAV全閉
		$('nav>ul>li>span>a>em').text('▶');
		$('nav>ul>li>ul').hide();

		// NAV OPEN
		$('#l_' + n).closest('ul').closest('li').children('span').children('a').children('em').text('▼');
		$('#l_' + n).closest('ul').show();

		// NAVサイド色
		$('nav>ul>li>ul>li>span>a').css('border-left', '11px solid #8fa2cc');
		$('#l_' + n).css('border-left', '11px solid #152144');

		// NAVサイドTRI
		$('nav>ul>li>ul>li').removeClass('now');
		$('#l_' + n).closest('li').addClass('now');

		// SEARCH HIDE
		if ($('.spHeader').css('display') === 'block') {	// IF SP
			$('#search').hide();
		}
		$("input").val('');

		// NAVスイッチ
		navDispSwitch(n);

		nowIn = n;

		// クエリハイライト
		var text = $('article#c_' + n).html().replace(/<em>/g, '');
		$('article#c_' + n).html(text);
		if (searchQuery !== '') {
			console.log('searchQuery:' + searchQuery);
			var re = new RegExp("(" + searchQuery + ")", 'igm');
			var text = $('article#c_' + n).html().replace(re, function () {
				return "<em>" + arguments[1] + "</em>";
			});
			$('article#c_' + n).html(text);
			searchQuery = '';
		} else {

		}

		$("img.lazy").lazyload({
			threshold: 99999999
		});
		if (a !== '') {
			var allImage = $('article#c_' + n + ' img');
			var allImageCount = allImage.length;
			var completeImageCount = 0;
			if (allImageCount === 0) {
				setTimeout(function () {
					$('html, body').animate({scrollTop: $('#' + a).offset().top}, 300, 'easeOutCubic');
				}, 100);
			} else {
				for (var i = 0; i < allImageCount; i++) {
					$(allImage[i]).bind("load", function () {
						completeImageCount++;
						if (allImageCount === completeImageCount) {
							setTimeout(function () {
								$('html, body').animate({scrollTop: $('#' + a).offset().top}, 300, 'easeOutCubic');
							}, 100);
						}
					});
				}
			}
		} else {
			$('html, body').scrollTop(0);
		}

		navFix();

		return false;
	}



	// NAVスイッチ
	function navDispSwitch(n) {
		if ($('.spHeader').css('display') === 'block') {
			// IF SP
			if (n !== 'index') {
				$('nav').hide();
				$('#spTopImage').hide();
			} else {
				$('nav').show();
				$('#spTopImage').show();
			}
		} else {
			// IF PC
			$('nav').show();
			$('#search').show();
			$('#spTopImage').hide();
			navFix();
		}
	}



	// リンク処理
	$(document).on('click', 'a[href^="#"]', function (e) {
		if ($(this).attr("href") === "#") {
			event.preventDefault();
			return false;
		} else if ($(this).attr("href") === "#top") {
			$('html, body').animate({scrollTop: 0}, 500, 'easeOutCubic');
			event.preventDefault();
			return false;
		} else {
			if (location.hash !== $(this).attr('href')) {
				location.hash = $(this).attr('href').substr(1);
			} else {
				var re = /^_search_/;
				if ($(this).attr('href').substr(1).match(re)) {
				} else {
					move($(this).attr('href').substr(1));
				}
			}
			event.preventDefault();
			return false;
		}
	});


	// 全ページプリント
	$(document).on('click', '#printAll', function () {
		$('article').show();
		$("img.lazy").lazyload({
			threshold: 99999999
		});
		$('article:not(:last-child)').css('page-break-after', 'always');

		$('#printCopy').show();

		window.print();

		$('#printCopy').hide();
		$('article').css('page-break-after', 'auto');
		$('article').hide();
		$('#c_index').show();

		event.preventDefault();
		return false;
	});

	window.onafterprint = function () {
		$('#printCopy').hide();
		$('article').css('page-break-after', 'auto');
		$('article').hide();
		move(nowIn);
	};


	// NAVI OPEN
	$('nav>ul>li>span>a').click(function (e) {
		// NAV全閉
		$('nav>ul>li>span>a>em').text('▶');
		$('nav>ul>li>ul').animate({height: 'hide'}, 100);
		if ($(this).closest('li').children('ul').is(':visible')) {
			$(this).children('em').text('▶');
			$(this).closest('li').children('ul').animate({height: 'hide'}, 100, "easeOutExpo", function () {
				navFix();
			});
			return false;
		} else {
			$(this).children('em').text('▼');
			$(this).closest('li').children('ul').animate({height: 'show'}, 100, "easeOutExpo", function () {
				navFix();
			});
			return false;
		}
	});


	//文字サイズ変更
	$("#text-size-change ul li").click(function () {
		$("#text-size-change ul li").removeClass("select");
		var textsize = $(this).attr("class");
		$(this).addClass("select");
		if (textsize === "small-text") {
			$("article,#searchResultsArea").css("font-size", "0.875em");
		} else if (textsize === "middle-text") {
			$("article,#searchResultsArea").css("font-size", "1em");
		} else if (textsize === "big-text") {
			$("article,#searchResultsArea").css("font-size", "1.15em");
		}

	});


	// SEARCH ON/OFF
	$('#search_button>a').click(function (e) {
		$('#search').animate({height: 'toggle'}, 100);
		$("#input-text").focus();
	});


	// 履歴窓生成
	function searchHistoryCreate() {
		if ($.cookie(cookieName)) {
			searchHistory = decodeURI($.cookie(cookieName)).split('|||||');
			$('#searchHistory').html('');
			for (var i = 0; i < searchHistory.length; i++) {
				$('#searchHistory').append('<li><a href="#_search_' + encodeURI(searchHistory[i]) + '">' + searchHistory[i] + '</a></li>');
			}
		} else {
			$('#searchHistory').html('');
		}
	}


	// 履歴窓表示
	$("#input-text").focus(function (e) {
		if (searchHistory.length > 0) {
			setTimeout(function () {
				$("#searchHistory").fadeIn(100);
			}, 100);
		}
	});
	$("#input-text").blur(function (e) {
		setTimeout(function () {
			$("#searchHistory").fadeOut(100);
		}, 100);
	});


	// 検索
	$("form").submit(function () {
		if ($("input").val()) {
			location.hash = '_search_' + encodeURI($("input").val());
			// 検索窓クリア
			$("input").val('');
			$("input").blur();
		}
		return false;
	});


	// 検索処理
	function search(q) {
		var q = q;
		searchQuery = q;

		// NAV全閉
		$('nav>ul>li>span>a>em').text('▶');
		$('nav>ul>li>ul').hide();
		// SP SEARCH HIDE
		if ($('.spHeader').css('display') === 'block') {	// IF SP
			$('#search').hide();
		}

		// 検索結果初期化
		$('#searchResultsArea>div.page').html('');
		$('#searchResultsArea>div.page').append('<section><em>' + q + '</em> の検索結果</section>');
		// 初期化
		$('article').hide();
		$('#searchResults').show();
		// SP SEARCH HIDE
		if ($('.spHeader').css('display') === 'block') {	// IF SP
			$('#spTopImage').hide();
			$('nav').hide();
		}

		// 記事総当たり
		var resultHtml = '';
		for (var i = 1; i < $("article").length; i++) {
			var title = $("article").eq(i).children('h1').text();
			var link = $("article").eq(i).attr("id").substr(2);
			var str = $("article").eq(i).text().replace(/[\n\r\t]/g, "");
			var re = new RegExp("(" + q + ")", 'igm');
			var result = str.match(re);
			// 結果生成
			if (result) {
				var text = RegExp.leftContext.substr(-200) + RegExp.lastMatch + RegExp.rightContext.substr(0, 200);
				text = text.replace(re, function () {
					return "<em>" + arguments[1] + "</em>";
				});
				resultHtml += '<section>';
				resultHtml += '<h2><a href="#' + link + '">' + title + '</a></h2>';
				resultHtml += '<p><a href="#' + link + '">' + text + '</a></p>';
				resultHtml += '</section>';
			}
		}

		// 結果なし
		if (resultHtml === '') {
			resultHtml += '<section>';
			resultHtml += '<em>' + q + '</em> に一致する結果は見つかりませんでした';
			resultHtml += '</section>';
		} else {

			// 履歴保存
			var c = q;
			if ($.cookie(cookieName)) {
				searchHistory = decodeURI($.cookie(cookieName)).split('|||||');
				// 同じ履歴が合ったら削除
				for (var i = 0; i < searchHistoryNum; i++) {
					if (searchHistory[i] === q) {
						searchHistory.splice(i, 1);
					}
				}

				for (i = 0; i < searchHistoryNum - 1; i++) {
					if (searchHistory[i]) {
						c += '|||||';
						c += searchHistory[i];
					} else {
						break;
					}
				}
			}
			console.log(c);
			$.cookie(cookieName, encodeURI(c));
			searchHistoryCreate();
		}

		$('#searchResultsArea>div.page').append(resultHtml);
		$("input").val(q);
		// NAVサイド色戻す
		$('nav>ul>li>ul>li>span>a').css('border-left', '11px solid #8fa2cc');
		// NAVサイドTRI戻す
		$('nav>ul>li>ul>li').removeClass('now');
	}


	// RESIZED
	$(window).resize(function () {
		navDispSwitch(nowIn);
	});
	checkTop(null);
	$(window).scroll(checkTop);
	$(window).resize(checkTop);
	function checkTop(e) {
		if ($(window).scrollTop() > 0) {
			$('#topButton').fadeIn(100);
		} else {
			$('#topButton').fadeOut(100);
		}
	}


	// HASH CHECK
	function hashCheck() {
		console.log('new hash:' + location.hash);
		if (location.hash) {
			nowIn = location.hash.substr(1);
		}
		// 検索かどうか
		var re = /^_search_/;
		//if (nowIn !== '_search') {
		if (nowIn.match(re)) {
			console.log('search mode');
			search(decodeURI(nowIn.split(re)[1]));
		} else {
			// 存在チェック
			console.log($('article#c_' + nowIn.split('__')[0]).length);
			if (!$('article#c_' + nowIn.split('__')[0].length)) {
				location.hash = 'index';
			} else {
				move(nowIn);
			}
		}
	}
	$(window).hashchange(function () {
		console.log('Hash Changed');
		hashCheck();
	});


	// ナビ固定
	function navFix() {
		var marginTop = 10;
		var startPoint = $('#nav').offset().top - marginTop;
		var scroll = $(window).scrollTop();
		if ($('nav').height() < $('#content').height()) {
			if (scroll > startPoint) {
				if (scroll + $('nav').height() < $('#content').offset().top + $('#content').height()) {
					console.log('fixed');
					$('nav').css({'position': 'fixed', 'top': marginTop + 'px'});
				} else {
					console.log('bottom');
					$('nav').css({'position': 'relative', 'top': $('#content').height() - $('nav').height() + 'px'});
				}
			} else {
				console.log('relative');
				$('nav').css({'position': 'relative', 'top': '0px'});
			}
		} else {
			console.log('default');
			$('nav').css({'position': 'relative', 'top': '0px'});
		}
	}
	$(window).scroll(function () {
		navFix();
	});


	// アコーディオンテーブル
	$('.accordionTable>dd').hide();
	$(document).on('click', '.accordionTable>dt', function () {
		console.log('accordion open');
		var p = $(this).parent();
		if ($('+dd', this).css('display') !== 'none') {
			$('+dd', this).stop(true, true).slideUp(300);
			$(this).removeClass('nowOpen');
		} else {
			$('>dt', p).removeClass('nowOpen');
			$('>dd', p).each(function () {
				if ($(this).css('display') !== 'none') {
					$(this).stop(true, true).slideUp(300);
				}
			});
			$('+dd', this).stop(true, true).slideDown(300);
			$(this).addClass('nowOpen');
		}
	});

});


