# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.conf.urls import patterns, include, url
from django.shortcuts import render_to_response
from django.http import HttpResponseRedirect
import os
from views import SetupView

base_directory = os.path.dirname(os.path.abspath(__file__))
templates_directory = os.path.join(base_directory, "templates")
template_file = os.path.join(templates_directory, "template.html")

urlpatterns = patterns('',
    url(r'^$', lambda r: HttpResponseRedirect('./setup')),
    url(r'^setup$', SetupView.as_view()),
)
